﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RandomNumbers
{
    class Program
    {
        static void Main(string[] args)
        {
            const int ITERATION_NUMBER = 10000;
            const int BITS_NUMBER = 1024; //1024

            byte[] buffer = new byte[BITS_NUMBER];
            {
                var watch = Stopwatch.StartNew();

                System.Security.Cryptography.RNGCryptoServiceProvider generator = new System.Security.Cryptography.RNGCryptoServiceProvider();
                for (int i = 0; i < ITERATION_NUMBER; i++)
                {
                    generator.GetBytes(buffer);
                    //BitConverter.ToInt32(buffer, 0);
                }

                watch.Stop();
                var elapsedMs = watch.ElapsedMilliseconds;
                Console.WriteLine(elapsedMs);
            }
            {
                var watch = Stopwatch.StartNew();

                Random generator = new Random();
                for (int i = 0; i < ITERATION_NUMBER; i++)
                {
                    generator.NextBytes(buffer);
                    //BitConverter.ToInt32(buffer, 0);
                }

                watch.Stop();
                var elapsedMs = watch.ElapsedMilliseconds;
                Console.WriteLine(elapsedMs);
            }
        }
    }
}
